id: sprectrum_tools_periodogram
label: periodogram
category: '[sprectrum_tools]'

templates:
  imports: import sprectrum_tools
  make: sprectrum_tools.periodogram(${sampling}, ${window}, ${NFFT}, ${scale_by_freq})

#  Make one 'parameters' list entry for every parameter you want settable from the GUI.
#     Keys include:
#     * id (makes the value accessible as \$keyname, e.g. in the make entry)
#     * label (label shown in the GUI)
#     * dtype (e.g. int, float, complex, byte, short, xxx_vector, ...)
parameters:
-   id: sampling
    label: sampling
    dtype: float
    default: '1.0'
-   id: window
    label: window
    dtype: enum
    options: ['"hann"', '"bartlett_hann"', '"blackman_harris"', '"blackman_nuttall"',
        '"bohman"', '"blackman"', '"chebwin"', '"gaussian"', '"hamming"', '"kaiser"',
        '"lanczos"', '"sinc"', '"poisson"', '"tukey"', '"nuttall"', '"parzen"', '"flattop"',
        '"riesz"', '"riemann"', '"hanning"', '"poisson_hanning"', '"rectangular"',
        '"rectangle"', '"bartlett"', '"triangular"', '"cosine"', '"sine"', '"cauchy"',
        '"taylor"']
    option_labels: [hann, bartlett_hann, blackman_harris, blackman_nuttall, bohman,
        blackman, chebwin, gaussian, hamming, kaiser, lanczos, sinc, poisson, tukey,
        nuttall, parzen, flattop, riesz, riemann, hanning, poisson_hanning, rectangular,
        rectangle, bartlett, triangular, cosine, sine, cauchy, taylor]
-   id: NFFT
    label: NFFT
    dtype: int
    default: '1024'
-   id: scale_by_freq
    label: scale_by_freq
    dtype: enum
    options: ['False', 'True']

#  Make one 'inputs' list entry per input and one 'outputs' list entry per output.
#  Keys include:
#      * label (an identifier for the GUI)
#      * domain (optional - stream or message. Default is stream)
#      * dtype (e.g. int, float, complex, byte, short, xxx_vector, ...)
#      * vlen (optional - data stream vector length. Default is 1)
#      * optional (optional - set to 1 for optional inputs. Default is 0)
inputs:
-   domain: stream
    dtype: complex
    vlen: ${ NFFT }

outputs:
-   domain: stream
    dtype: float
    vlen: ${ NFFT }

documentation: "https://pyspectrum.readthedocs.io/en/latest/autosum.html\n\nLa clase\
    \ Periodogram proporciona una interfaz para PSD de periodograma.\n\nclass Periodogram(data,\
    \ sampling=1.0, window='hann', NFFT=None, scale_by_freq=False, detrend=None) \n\
    \nNombre Tipo de dato Descripci\xF3n\nData:(array)input data (list o numpy.array)\n\
    sampling:(float)frecuencia de muestreo de la entrada\_data.\nwindow:(str)Nombre\
    \ de la ventana\nNFFT:(int)Tama\xF1o total del conjunto de datos final (valor\
    \ predeterminado 4096).\nscale_by_freq:(bool)Toma valores de False o True\ndetrend:(str)detrend\
    \ los datos antes de co, puteando la FFT"

#  'file_format' specifies the version of the GRC yml format used in the file
#  and should usually not be changed.
file_format: 1
